## kio-extras 25.11.80

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# KDE Applications Version, managed by release script
set (RELEASE_SERVICE_VERSION_MAJOR "25")
set (RELEASE_SERVICE_VERSION_MINOR "11")
set (RELEASE_SERVICE_VERSION_MICRO "80")
set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
project(kio-extras VERSION ${RELEASE_SERVICE_VERSION})

set(QT_MIN_VERSION "6.5.0")
set(KF_MIN_VERSION "6.0.0")

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${ECM_MODULE_PATH})

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDEGitCommitHooks)

include(ECMMarkNonGuiExecutable)
include(ECMMarkAsTest)
include(ECMOptionalAddSubdirectory)
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(CheckIncludeFile)
include(CMakePushCheckState)
include(CMakePackageConfigHelpers)
include(FeatureSummary)

option(BUILD_DOC "Whether to build the documentation" ON)
option(BUILD_KCMS "Whether to build the KCMs" ON)
option(BUILD_FUZZERS "Whether to the thumbnail build fuzzers" OFF)
option(FUZZERS_USE_QT_MINIMAL_INTEGRATION_PLUGIN "Whether to use the Qt minimal integration plugin for fuzzers" OFF)

find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Gui Network Widgets Svg)

find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS
    Archive
    Config
    CoreAddons
    I18n
    KIO
    Solid
    SyntaxHighlighting
)

if(BUILD_KCMS)
    find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS KCMUtils)
endif()

# shall we use DBus?
# enabled per default on Linux & BSD systems
set(USE_DBUS_DEFAULT OFF)
if(UNIX AND NOT APPLE AND NOT ANDROID AND NOT HAIKU)
    set(USE_DBUS_DEFAULT ON)
endif()
option(USE_DBUS "Build components using DBus" ${USE_DBUS_DEFAULT})
if(USE_DBUS)
    find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS DBus)
    find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS DBusAddons)
endif()

if(LINUX)
    option(WITH_LIBPROXY "Build with libproxy, required for WPAD problem detection" ON)
endif()
if(WITH_LIBPROXY)
    find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS Notifications)
    find_package(PkgConfig)
    pkg_check_modules(libproxy REQUIRED IMPORTED_TARGET libproxy-1.0)
    add_feature_info("libproxy" libproxy_FOUND "libproxy for WPAD problem detection (kcm_proxy)")
endif()

find_package(Qt6Test ${QT_MIN_VERSION} CONFIG QUIET)
set_package_properties(Qt6Test PROPERTIES
         PURPOSE "Required for tests"
         TYPE OPTIONAL
         )
add_feature_info("Qt6Test" Qt6Test_FOUND "Required for building tests")
if (NOT Qt6Test_FOUND)
    set(BUILD_TESTING OFF CACHE BOOL "Build the testing tree.")
endif()

include(KDEClangFormat)
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

if (NOT WIN32 AND USE_DBUS)
    option(BUILD_ACTIVITIES "Build recentlyused:/, activities:/ KIO workers and fileitem plugin." ON)
    if(BUILD_ACTIVITIES)
        find_package(Qt6Sql REQUIRED)
        find_package(PlasmaActivities REQUIRED)
        find_package(PlasmaActivitiesStats REQUIRED)
    endif()
endif()

if (BUILD_DOC)
    find_package(KF6DocTools ${KF_MIN_VERSION})
    set_package_properties(KF6DocTools PROPERTIES
        DESCRIPTION "Tools to generate documentation"
        TYPE REQUIRED
    )
endif()

include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(NOT WIN32)
    # we need a version of samba which has already smbc_set_context(), Alex
    set(SAMBA_REQUIRE_SMBC_SET_CONTEXT TRUE)
    set(SAMBA_REQUIRE_SMBC_OPTION_SET TRUE)
    find_package(Samba)
    set_package_properties(Samba PROPERTIES DESCRIPTION "the SMB client library, a version with smbc_set_context() and smbc_option_set()"
                        URL "https://www.samba.org/"
                        TYPE OPTIONAL
                        PURPOSE "Needed to build the SMB KIO worker"
                        )
endif()

find_package(libssh 0.8.3 MODULE)
set_package_properties(libssh PROPERTIES DESCRIPTION "the SSH library with SFTP support"
                       URL "https://www.libssh.org/"
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the SFTP KIO worker"
                      )

find_package(Libmtp 1.1.2)
set_package_properties(Libmtp PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the MTP KIO worker"
                       )

find_package(IMobileDevice)
set_package_properties(IMobileDevice PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the AFC (Apple File Conduit) KIO worker"
                      )

find_package(PList)
set_package_properties(PList PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the AFC (Apple File Conduit) KIO worker"
                      )

check_include_file(utime.h HAVE_UTIME_H)

# ECM's KDECompilerSettings.cmake should take care of enabling supporting on
# 32bit architectures.
# Thorw a fatal error if off_t isn't >=64bit to ensure that large files are working
# as expected.
# BUG: 165449
if(UNIX)
    check_cxx_source_compiles("
        #include <sys/types.h>
        /* Check that off_t can represent 2**63 - 1 correctly.
            We can't simply define LARGE_OFF_T to be 9223372036854775807,
            since some C++ compilers masquerading as C compilers
            incorrectly reject 9223372036854775807.  */
        #define LARGE_OFF_T (((off_t) 1 << 62) - 1 + ((off_t) 1 << 62))

        int off_t_is_large[(LARGE_OFF_T % 2147483629 == 721 && LARGE_OFF_T % 2147483647 == 1) ? 1 : -1];
        int main() { return 0; }
    "
    OFFT_IS_64BIT)

    if(NOT OFFT_IS_64BIT)
        message(FATAL_ERROR "Large file support is not enabled.")
    endif()

    find_package(Gperf)
    set_package_properties(Gperf PROPERTIES TYPE OPTIONAL
                           PURPOSE "Needed to build the man KIO worker"
                           )

    find_package(TIRPC)
    set_package_properties(TIRPC PROPERTIES TYPE OPTIONAL
                           PURPOSE "Needed to build the NFS KIO worker"
                           )
else()
    # FIXME: on windows we ignore support until trash gets integrated
endif()

ecm_set_disabled_deprecation_versions(
    QT 5.15.2
    KF 6.0
)

if(BUILD_KCMS)
    add_subdirectory( kcms )
endif()

if(BUILD_ACTIVITIES)
  add_subdirectory( activities )
  add_subdirectory( recentlyused )
endif()
add_subdirectory( filter )
add_subdirectory( info )
add_subdirectory( archive )
if (NOT WIN32)
    # does not compile: fish.cpp(41): fatal error C1083: Cannot open include file: 'sys/resource.h': No such file or directory
    # Used for getting the resource limit for closing all child process FDs. Could be completely replaced by fcloseall() if available for Unix or _fcloseall() for Windows, either conditionally on Q_OS_type or using a configure test.
    add_subdirectory( fish )
endif()
add_subdirectory( thumbnail )
if (libssh_FOUND)
    find_package(QCoro6 REQUIRED COMPONENTS Core)
    qcoro_enable_coroutines()
    add_subdirectory(sftp)
endif ()

if (NOT WIN32 AND NOT APPLE AND USE_DBUS)
    add_subdirectory( filenamesearch )
endif()

if (Libmtp_FOUND AND USE_DBUS)
  add_subdirectory(mtp)
endif()

if(NOT WIN32)
   if(Gperf_FOUND)
     add_subdirectory( man )
   endif()
   if(TIRPC_FOUND)
     add_subdirectory( nfs )
   endif()
endif()

if(SAMBA_FOUND AND USE_DBUS)
    find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS DNSSD)
    add_subdirectory(smb)
endif()

if(IMobileDevice_FOUND AND PList_FOUND)
    add_subdirectory(afc)
endif()

configure_file (config-runtime.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-runtime.h )

ecm_qt_install_logging_categories(
    EXPORT KIO_EXTRAS
    FILE kio-extras.categories
    DESTINATION "${KDE_INSTALL_LOGGINGCATEGORIESDIR}"
)

if(BUILD_DOC)
    add_subdirectory(doc)
    kdoctools_install(po)
endif()

ki18n_install(po)

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== fish/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio6_fish\")

remove_definitions(-DQT_NO_CAST_FROM_ASCII)

include(CheckIncludeFiles)
include(CheckFunctionExists)

check_include_files(termios.h HAVE_TERMIOS_H)
check_include_files(util.h HAVE_UTIL_H)
check_include_files(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_files(pty.h HAVE_PTY_H)
check_include_files("sys/types.h;libutil.h" HAVE_LIBUTIL_H)
check_function_exists(getpt       HAVE_GETPT)
check_function_exists(grantpt     HAVE_GRANTPT)
include(CheckLibraryExists)
check_library_exists(util  openpty "" HAVE_OPENPTY)
check_library_exists(util  isastream "" HAVE_ISASTREAM)

find_library(UTIL_LIBRARIES util)
mark_as_advanced(UTIL_LIBRARIES)

configure_file(config-fish.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-fish.h)

########### next target ###############
# on Linux there is md5sum, on FreeBSD there is md5
find_program(MD5SUM_EXECUTABLE NAMES md5sum md5 )

if (MD5SUM_EXECUTABLE)

   add_library(kio_fish MODULE)
   set_target_properties(kio_fish PROPERTIES
      OUTPUT_NAME "fish"
   )

   if ("${MD5SUM_EXECUTABLE}" MATCHES "md5sum")
      set(CUT_ARG "-f 1")                            # for md5sum the sum is in the 1st column
   else ()
      set(CUT_ARG "-f 4")                            # for md5 the sum is in the 4th column
   endif ()

   if (WIN32)
      set(FISH_GENERATOR "generate_fishcode.bat")
   else ()
      set(FISH_GENERATOR "generate_fishcode.sh")
   endif ()
   set(fishcode_HDR "${CMAKE_CURRENT_BINARY_DIR}/fishcode.h")
   add_custom_command(OUTPUT ${fishcode_HDR}
      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${FISH_GENERATOR} ARGS ${CMAKE_CURRENT_SOURCE_DIR}/fish.pl ${MD5SUM_EXECUTABLE} ${fishcode_HDR} "${CUT_ARG}"
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/fish.pl
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )
   set_source_files_properties(${fishcode_HDR} PROPERTIES SKIP_AUTOMOC TRUE)

   target_sources(kio_fish PRIVATE
      fish.cpp
      ${fishcode_HDR}
   )

   ecm_qt_declare_logging_category(kio_fish
      HEADER loggingcategory.h
      IDENTIFIER KIO_FISH_DEBUG
      CATEGORY_NAME kf.kio.workers.fish
      OLD_CATEGORY_NAMES kio_fish kf.kio.slaves.fish
      DEFAULT_SEVERITY Info
      DESCRIPTION "KIO fish"
      EXPORT KIO_EXTRAS
   )

   target_link_libraries(kio_fish KF6::KIOCore KF6::I18n Qt::Network)

   if (UTIL_LIBRARIES)
      target_link_libraries(kio_fish ${UTIL_LIBRARIES})
   endif ()

   install(TARGETS kio_fish  DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kio )

endif ()

=== thumbnail/CMakeLists.txt ===
if (BUILD_TESTING)
    add_subdirectory(autotests)
endif()

add_definitions(-DTRANSLATION_DOMAIN=\"kio6_thumbnail\")

remove_definitions(-DQT_NO_CAST_FROM_ASCII)

find_package(OpenEXR 3.0 CONFIG QUIET)
if(NOT OpenEXR_FOUND)
    find_package(OpenEXR)
endif()
set_package_properties(OpenEXR PROPERTIES
    DESCRIPTION "A library for handling OpenEXR high dynamic-range image files"
    URL "https://www.openexr.com/"
    TYPE OPTIONAL
    PURPOSE "Provides support for OpenEXR formatted images in the thumbnail KIO worker"
)

find_package(libappimage 0.1.10 CONFIG)
set_package_properties(libappimage PROPERTIES
    DESCRIPTION "Core library of the AppImage project"
    URL "https://github.com/AppImage/libappimage"
    TYPE OPTIONAL
    PURPOSE "Provides support for AppImage thumbnails"
)

option(WITHOUT_X11 "Build without support for XCursor thumbnails (disables finding X11)" OFF)
if (NOT WITHOUT_X11)
    find_package(X11)
    set_package_properties(X11 PROPERTIES
        DESCRIPTION "X11 libraries"
        URL "https://www.x.org"
        TYPE OPTIONAL
        PURPOSE "Provides support for XCursor thumbnails"
    )
endif()

find_package(Taglib 1.11)
set_package_properties(Taglib PROPERTIES
    TYPE OPTIONAL
    PURPOSE "Provides support for audio thumbnails"
)

find_package(KExiv2Qt6)
set_package_properties(KExiv2Qt6 PROPERTIES
    TYPE OPTIONAL
    PURPOSE "Provides support for extracting JPEG thumbnails")
if (KExiv2Qt6_FOUND)
    set(HAVE_KEXIV2 TRUE)
endif()

include_directories(${CMAKE_BINARY_DIR})

include(ECMSetupQtPluginMacroNames)
ecm_setup_qtplugin_macro_names(
    JSON_ARG2
        "EXPORT_THUMBNAILER_WITH_JSON"
    CONFIG_CODE_VARIABLE
        PACKAGE_SETUP_AUTOMOC_VARIABLES
)

configure_file(config-thumbnail.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-thumbnail.h)

########### next target ###############

add_library(kio_thumbnail MODULE)
set_target_properties(kio_thumbnail PROPERTIES
    OUTPUT_NAME "thumbnail"
)

target_sources(kio_thumbnail PRIVATE
    thumbnail.cpp
    imagefilter.cpp
)

ecm_qt_declare_logging_category(kio_thumbnail
    HEADER thumbnail-logsettings.h
    IDENTIFIER KIO_THUMBNAIL_LOG
    CATEGORY_NAME kf.kio.workers.thumbnail
    OLD_CATEGORY_NAMES log_kio_thumbnail kf.kio.slaves.thumbnail
    DESCRIPTION "KIO thumbnail"
    EXPORT KIO_EXTRAS
)

target_link_libraries(kio_thumbnail
    PUBLIC
        Qt6::Widgets
        KF6::CoreAddons
        KF6::KIOCore
        KF6::KIOGui
        KF6::I18n
)

install(TARGETS kio_thumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kio)

########### next target ###############

kcoreaddons_add_plugin(imagethumbnail
    INSTALL_NAMESPACE "kf6/thumbcreator"
    SOURCES imagecreator.cpp
)

target_link_libraries(imagethumbnail
    KF6::CoreAddons
    KF6::KIOGui
)

########### next target ###############

kcoreaddons_add_plugin(jpegthumbnail
    INSTALL_NAMESPACE "kf6/thumbcreator"
    SOURCES jpegcreator.cpp
)

kconfig_add_kcfg_files(jpegthumbnail jpegcreatorsettings5.kcfgc)

target_link_libraries(jpegthumbnail
    Qt::Core
    Qt::Gui
    KF6::KIOCore
    KF6::KIOGui
    KF6::I18n
    KF6::ConfigCore
    KF6::ConfigGui
)
if (TARGET KExiv2Qt6)
    target_link_libraries(jpegthumbnail KExiv2Qt6)
endif()

install(FILES jpegcreatorsettings5.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

########### next target ###############

kcoreaddons_add_plugin(svgthumbnail
    INSTALL_NAMESPACE "kf6/thumbcreator"
    SOURCES svgcreator.cpp
)

target_link_libraries(svgthumbnail
    Qt::Gui
    Qt::Svg
    KF6::KIOCore
    KF6::KIOGui
)

########### next target ###############

kcoreaddons_add_plugin(textthumbnail
    INSTALL_NAMESPACE "kf6/thumbcreator"
    SOURCES textcreator.cpp
)

target_link_libraries(textthumbnail
    Qt::Gui
    KF6::KIOGui
    KF6::SyntaxHighlighting
)

########### next target ###############

if(NOT WIN32)

    kcoreaddons_add_plugin(djvuthumbnail
        INSTALL_NAMESPACE "kf6/thumbcreator"
        SOURCES djvucreator.cpp
    )

    ecm_qt_declare_logging_category(djvuthumbnail
        HEADER thumbnail-djvu-logsettings.h
        IDENTIFIER KIO_THUMBNAIL_DJVU_LOG
        CATEGORY_NAME kf.kio.workers.thumbnail.djvu
        OLD_CATEGORY_NAMES log_kio_thumbnail.djvu kf.kio.slaves.thumbnail.djvu
        DESCRIPTION "DjVu files thumbnailer"
        EXPORT KIO_EXTRAS
    )

    target_link_libraries(djvuthumbnail KF6::KIOGui)

endif()

########### next target ###############

if(OpenEXR_FOUND)

    kcoreaddons_add_plugin(exrthumbnail
        INSTALL_NAMESPACE "kf6/thumbcreator"
        SOURCES exrcreator.cpp
    )

    ecm_qt_declare_logging_category(exrthumbnail
        HEADER thumbnail-exr-logsettings.h
        IDENTIFIER KIO_THUMBNAIL_EXR_LOG
        CATEGORY_NAME kf.kio.workers.thumbnail.exr
        OLD_CATEGORY_NAMES log_kio_thumbnail.exr kf.kio.slaves.thumbnail.exr
        DESCRIPTION "EXR images thumbnailer"
        EXPORT KIO_EXTRAS
    )

    target_link_libraries(exrthumbnail
        KF6::KIOCore
        KF6::KIOGui
    )
    if(TARGET OpenEXR::OpenEXR)
        target_link_libraries(exrthumbnail OpenEXR::OpenEXR)
    else()
        target_include_directories(exrthumbnail SYSTEM PRIVATE ${OpenEXR_INCLUDE_DIRS})
        target_link_libraries(exrthumbnail ${OpenEXR_LIBRARIES})
    endif()

    # OpenEXR headers use exceptions; at least clang refuses to build the target
    # when exceptions are not enabled.
    kde_source_files_enable_exceptions(exrcreator.cpp)

endif()

########### next target ###############

if(X11_Xcursor_FOUND AND NOT WITHOUT_X11)

    kcoreaddons_add_plugin(cursorthumbnail
        INSTALL_NAMESPACE "kf6/thumbcreator"
        SOURCES cursorcreator.cpp
    )

    target_link_libraries(cursorthumbnail
        KF6::KIOCore
        KF6::KIOGui
        KF6::CoreAddons
        ${X11_Xcursor_LIB}
    )

endif()

########### next target ###############

kcoreaddons_add_plugin(windowsexethumbnail
    INSTALL_NAMESPACE "kf6/thumbcreator"
    SOURCES windowsexecreator.cpp icoutils.cpp exeutils.cpp
)
kcoreaddons_add_plugin(windowsimagethumbnail
    INSTALL_NAMESPACE "kf6/thumbcreator"
    SOURCES windowsimagecreator.cpp icoutils.cpp exeutils.cpp
)

target_link_libraries(windowsexethumbnail KF6::KIOGui)
target_link_libraries(windowsimagethumbnail KF6::KIOGui)

########### next target ###############

kcoreaddons_add_plugin(comicbookthumbnail
    INSTALL_NAMESPACE "kf6/thumbcreator"
    SOURCES comiccreator.cpp
)

ecm_qt_declare_logging_category(comicbookthumbnail
    HEADER thumbnail-comic-logsettings.h
    IDENTIFIER KIO_THUMBNAIL_COMIC_LOG
    CATEGORY_NAME kf.kio.workers.thumbnail.comic
    OLD_CATEGORY_NAMES log_kio_thumbnail.comic kf.kio.slaves.thumbnail.comic
    DESCRIPTION "Comic books thumbnailer"
    EXPORT KIO_EXTRAS
)

target_link_libraries(comicbookthumbnail
    Qt::Gui
    KF6::Archive
    KF6::KIOGui
)

# ########### next target ###############

kcoreaddons_add_plugin(kraorathumbnail
    INSTALL_NAMESPACE "kf6/thumbcreator"
    SOURCES kritacreator.cpp
)

target_link_libraries(kraorathumbnail
    KF6::KIOGui
    KF6::Archive
)

########### next target #################

if(Taglib_FOUND)

    kcoreaddons_add_plugin(audiothumbnail
        INSTALL_NAMESPACE "kf6/thumbcreator"
        SOURCES audiocreator.cpp
    )

    target_link_libraries(audiothumbnail
        Taglib::Taglib
        KF6::KIOGui
    )

endif()

# ########### next target ###############

kcoreaddons_add_plugin(opendocumentthumbnail
    INSTALL_NAMESPACE "kf6/thumbcreator"
    SOURCES opendocumentcreator.cpp
)

target_link_libraries(opendocumentthumbnail
    Qt::Gui
    KF6::KIOGui
    KF6::Archive
)

# ########### next target ###############

if(libappimage_FOUND)

    kcoreaddons_add_plugin(appimagethumbnail
        INSTALL_NAMESPACE "kf6/thumbcreator"
        SOURCES appimagecreator.cpp
    )

    target_link_libraries(appimagethumbnail
        KF6::KIOGui
        Qt::Gui
        libappimage
    )

endif()

# ########### next target ###############

kcoreaddons_add_plugin(ebookthumbnail
    INSTALL_NAMESPACE "kf6/thumbcreator"
    SOURCES ebookcreator.cpp
)

target_link_libraries(ebookthumbnail
    Qt::Gui
    KF6::KIOGui
    KF6::Archive
)

# ########### next target ###############

kcoreaddons_add_plugin(directorythumbnail
    INSTALL_NAMESPACE "kf6/thumbcreator"
    SOURCES directorycreator.cpp
)

target_link_libraries(directorythumbnail
    Qt::Gui
    KF6::CoreAddons
    KF6::KIOGui
)

if(BUILD_FUZZERS)
    if(BUILD_SHARED_LIBS)
        message(FATAL_ERROR "Fuzzers can only be built with static libraries")
    else()
        add_subdirectory(autotests/ossfuzz)
    endif()
endif()

=== activities/fileitemplugin/CMakeLists.txt ===
# vim:set softtabstop=3 shiftwidth=3 tabstop=3 expandtab:

add_library(kactivitymanagerd_fileitem_linking_plugin MODULE)

target_sources(kactivitymanagerd_fileitem_linking_plugin PRIVATE
   FileItemLinkingPlugin.cpp
   FileItemLinkingPluginActionLoader.cpp
   ../utils/qsqlquery_iterator.cpp
   )

target_link_libraries (
   kactivitymanagerd_fileitem_linking_plugin
   Qt::Core
   Qt::Sql
   KF6::KIOFileWidgets
   KF6::I18n
   Plasma::Activities
   )

install (
   TARGETS kactivitymanagerd_fileitem_linking_plugin
   DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kfileitemaction
   )

=== filenamesearch/autotests/CMakeLists.txt ===
# allow coercing cstring to qstring, easier to write
remove_definitions(-DQT_NO_CAST_FROM_ASCII)

find_package(Qt6Test ${QT_MIN_VERSION} CONFIG REQUIRED)

include(ECMAddTests)

ecm_add_tests(
    filenamesearchtest.cpp
    filenamesearchexternaltest.cpp
    LINK_LIBRARIES
        Qt::Test
        KF6::KIOWidgets
)

=== kcms/netpref/CMakeLists.txt ===
kcoreaddons_add_plugin(kcm_netpref INSTALL_NAMESPACE "plasma/kcms/systemsettings_qwidgets")

kcmutils_generate_desktop_file(kcm_netpref)
target_sources(kcm_netpref PRIVATE
    netpref.cpp
    ../ksaveioconfig.cpp
)

kconfig_add_kcfg_files(kcm_netpref kio_ftprc.kcfgc)
kconfig_add_kcfg_files(kcm_netpref kioslave.kcfgc)

target_link_libraries(kcm_netpref
  PUBLIC
    KF6::ConfigCore
    KF6::KCMUtils
    KF6::KIOCore
  PRIVATE
    KF6::I18n
    KF6::CoreAddons
)

if(USE_DBUS)
  target_link_libraries(kcm_netpref PUBLIC Qt6::DBus)
  target_compile_definitions(kcm_netpref PUBLIC -DWITH_DBUS)
endif()

=== kcms/proxy/CMakeLists.txt ===
if(WITH_LIBPROXY)
    add_subdirectory(wpad-detector)
endif()

kcoreaddons_add_plugin(kcm_proxy INSTALL_NAMESPACE "plasma/kcms/systemsettings_qwidgets")

kcmutils_generate_desktop_file(kcm_proxy)

target_sources(kcm_proxy PRIVATE
    kproxydlg.cpp
    ../ksaveioconfig.cpp
)

ki18n_wrap_ui(kcm_proxy kproxydlg.ui)

kconfig_add_kcfg_files(kcm_proxy kioslave.kcfgc)

target_link_libraries(kcm_proxy PRIVATE
    Qt6::Widgets
    KF6::CoreAddons
    KF6::ConfigCore
    KF6::I18n
    KF6::KCMUtils
    KF6::KIOWidgets
)

if(USE_DBUS)
  target_link_libraries(kcm_proxy PRIVATE Qt6::DBus)
  target_compile_definitions(kcm_proxy PUBLIC -DWITH_DBUS)
endif()

=== kcms/webshortcuts/CMakeLists.txt ===
kcoreaddons_add_plugin(kcm_webshortcuts INSTALL_NAMESPACE "plasma/kcms/systemsettings_qwidgets")

target_sources(kcm_webshortcuts PRIVATE
    ikwsopts.cpp
    searchprovider.cpp
    searchproviderdlg.cpp
    searchproviderregistry.cpp
)

kcmutils_generate_desktop_file(kcm_webshortcuts)
ki18n_wrap_ui(kcm_webshortcuts ikwsopts_ui.ui searchproviderdlg_ui.ui)

target_link_libraries(kcm_webshortcuts
    KF6::KCMUtils # KCModule
    KF6::KIOWidgets    # KUriFilter
    KF6::I18n
    KF6::CoreAddons
)

if(USE_DBUS)
  target_link_libraries(kcm_webshortcuts Qt6::DBus)
  target_compile_definitions(kcm_webshortcuts PUBLIC -DWITH_DBUS)
endif()

=== doc/kioworker/zstd/CMakeLists.txt ===
########### install files ###############
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kioworker6/zstd)

=== thumbnail/autotests/ossfuzz/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 Azhar Momin <azhar.momin@kdemail.net>
# SPDX-License-Identifier: BSD-2-Clause

if(DEFINED ENV{LIB_FUZZING_ENGINE})
    set(fuzzing_engine $ENV{LIB_FUZZING_ENGINE})
else()
    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        set(fuzzing_engine -fsanitize=fuzzer)
    else()
        message(FATAL_ERROR "Fuzzing engine not supported")
    endif()
endif()

function(add_thumbnail_fuzzer creator creator_header target_lib)
    set(gen_src ${CMAKE_CURRENT_BINARY_DIR}/${target_lib}_fuzzer.cc)
    set(CREATOR "${creator}")
    set(CREATOR_HEADER "${creator_header}")
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/kde_thumbnailers_fuzzer.cc.in
        ${gen_src}
        @ONLY
    )

    add_executable(${target_lib}_fuzzer
        ${gen_src}
    )

    kcoreaddons_target_static_plugins(${target_lib}_fuzzer
        LINK_OPTION PRIVATE
        TARGETS ${target_lib}
    )

    target_link_libraries(${target_lib}_fuzzer
        PRIVATE
            ${fuzzing_engine}
    )

    if(FUZZERS_USE_QT_MINIMAL_INTEGRATION_PLUGIN)
        qt_import_plugins(${target_lib}_fuzzer INCLUDE Qt::QMinimalIntegrationPlugin)
    endif()

    set_target_properties(${target_lib}_fuzzer PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/fuzzers
    )
endfunction()

add_thumbnail_fuzzer(ImageCreator imagecreator.h imagethumbnail)

add_thumbnail_fuzzer(JpegCreator jpegcreator.h jpegthumbnail)

add_thumbnail_fuzzer(SvgCreator svgcreator.h svgthumbnail)

add_thumbnail_fuzzer(TextCreator textcreator.h textthumbnail)

if(NOT WIN32)
    add_thumbnail_fuzzer(DjVuCreator djvucreator.h djvuthumbnail)
endif()

if(OpenEXR_FOUND)
    add_thumbnail_fuzzer(EXRCreator exrcreator.h exrthumbnail)
endif()

if(X11_Xcursor_FOUND AND NOT WITHOUT_X11)
    add_thumbnail_fuzzer(CursorCreator cursorcreator.h cursorthumbnail)
endif()

add_thumbnail_fuzzer(WindowsExeCreator windowsexecreator.h windowsexethumbnail)

add_thumbnail_fuzzer(WindowsImageCreator windowsimagecreator.h windowsimagethumbnail)

add_thumbnail_fuzzer(ComicCreator comiccreator.h comicbookthumbnail)

add_thumbnail_fuzzer(KritaCreator kritacreator.h kraorathumbnail)

add_thumbnail_fuzzer(AudioCreator audiocreator.h audiothumbnail)

add_thumbnail_fuzzer(OpenDocumentCreator opendocumentcreator.h opendocumentthumbnail)

if(libappimage_FOUND)
    add_thumbnail_fuzzer(AppImageCreator appimagecreator.h appimagethumbnail)
endif()

add_thumbnail_fuzzer(EbookCreator ebookcreator.h ebookthumbnail)

=== debian/changelog ===
kio-extras (4:25.11.80-0ubuntu1) resolute; urgency=medium

  * New upstream (beta) release (25.11.80)

 -- Rik Mills <rikmills@kde.org>  Sun, 16 Nov 2025 07:57:00 +0000

=== debian/control ===
Source: kio-extras
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf6,
               extra-cmake-modules (>= 6.0.0~),
               gettext,
               gperf,
               libappimage-dev (>= 0.1.10~) [linux-any],
               libimobiledevice-dev,
               libkdsoapwsdiscoveryclient-dev,
               libkexiv2qt6-dev (>= 25.11.80~),
               libkf6archive-dev (>= 6.0.0~),
               libkf6codecs-dev,
               libkf6config-dev (>= 6.0.0~),
               libkf6configwidgets-dev (>= 6.0.0~),
               libkf6coreaddons-dev (>= 6.0.0~),
               libkf6dbusaddons-dev (>= 6.0.0~),
               libkf6dnssd-dev (>= 6.0.0~),
               libkf6doctools-dev (>= 6.0.0~),
               libkf6guiaddons-dev (>= 6.0.0~),
               libkf6i18n-dev (>= 6.0.0~),
               libkf6kcmutils-dev (>= 6.0.0~),
               libkf6kio-dev (>= 6.0.0~),
               libkf6notifications-dev (>= 6.0.0~),
               libkf6solid-dev (>= 6.0.0~),
               libkf6syntaxhighlighting-dev (>= 6.0.0~),
               libkf6textwidgets-dev (>= 6.0.0~),
               libmtp-dev (>= 1.1.2~),
               libopenexr-dev (>= 3.0~),
               libphonon4qt6-dev (>= 4:4.6.60~),
               libphonon4qt6experimental-dev (>= 4:4.12.0~),
               libplasmaactivities-dev,
               libplasmaactivitiesstats-dev,
               libplist-dev,
               libproxy-dev,
               libsmbclient-dev,
               libssh-dev (>= 0.8.3~),
               libtag-dev (>= 1.11~),
               libtirpc-dev,
               libxcursor-dev,
               pkgconf,
               qcoro-qt6-dev,
               qt6-5compat-dev (>= 6.5.0~),
               qt6-base-dev (>= 6.5.0+dfsg~),
               qt6-base-private-dev (>= 6.5.0~),
               qt6-svg-dev (>= 6.5.0~),
               shared-mime-info (>= 1.3~),
Standards-Version: 4.7.2
Homepage: https://invent.kde.org/network/kio-extras
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kio-extras
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kio-extras
Rules-Requires-Root: no

Package: kio-extras
Architecture: any
Depends: kio-extras-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: libkf6kcmutils-bin, systemsettings,
Breaks: kio (<< 5.115.0-7~), kio-extras-data (<< 4:24.12.2-2~),
Replaces: kio (<< 5.115.0-7~), kio-extras-data (<< 4:24.12.2-2~),
Description: Extra functionality for kioslaves
 A kioslave is a plugin designed to be intimately familiar with a certain
 protocol, so that a standardized interface can be used to get at data from
 any number of places.  A few examples are the http and ftp kioslaves,
 which using nearly identical methods will retrieve data from an http or
 ftp server respectively.
 .
 This package is part of the KDE base workspace module.

Package: kio-extras-data
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends},
Breaks: kio-extras (<< 4:24.12.2-2~), kio-mtp (<< 0.75+git20140304-1ubuntu1~),
Replaces: kio-extras (<< 4:24.12.2-2~), kio-mtp (<< 0.75+git20140304-1ubuntu1~),
Description: Extra functionality for kioslaves data files
 A kioslave is a plugin designed to be intimately familiar with a certain
 protocol, so that a standardized interface can be used to get at data from
 any number of places.  A few examples are the http and ftp kioslaves,
 which using nearly identical methods will retrieve data from an http or
 ftp server respectively.
 .
 This package contains the data files.

## kio-extras 25.11.90

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # KDE Applications Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
 set (RELEASE_SERVICE_VERSION_MINOR "11")
-set (RELEASE_SERVICE_VERSION_MICRO "80")
+set (RELEASE_SERVICE_VERSION_MICRO "90")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 project(kio-extras VERSION ${RELEASE_SERVICE_VERSION})

=== debian/changelog ===
kio-extras (4:25.11.90-0ubuntu1) resolute; urgency=medium

  * New upstream (RC) release (25.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 28 Nov 2025 14:06:38 +0000

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                libappimage-dev (>= 0.1.10~) [linux-any],
                libimobiledevice-dev,
                libkdsoapwsdiscoveryclient-dev,
-               libkexiv2qt6-dev (>= 25.11.80~),
+               libkexiv2qt6-dev (>= 25.11.90~),
                libkf6archive-dev (>= 6.0.0~),
                libkf6codecs-dev,
                libkf6config-dev (>= 6.0.0~),

## kio-extras 25.12.0

=== debian/changelog ===
kio-extras (4:25.12.0-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.12.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 11 Dec 2025 12:22:28 +0000

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                libappimage-dev (>= 0.1.10~) [linux-any],
                libimobiledevice-dev,
                libkdsoapwsdiscoveryclient-dev,
-               libkexiv2qt6-dev (>= 25.11.90~),
+               libkexiv2qt6-dev (>= 25.12.0~),
                libkf6archive-dev (>= 6.0.0~),
                libkf6codecs-dev,
                libkf6config-dev (>= 6.0.0~),

## kio-extras 25.12.0+p24.04+vstable+git20251224.0549

=== debian/changelog ===
kio-extras (4:25.12.0+p24.04+vstable+git20251224.0549-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 24 Dec 2025 05:49:18 +0000

kio-extras (4:25.12.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 08 Dec 2025 19:40:43 +1000

## kio-extras 25.12.0+p24.04+vstable+git20260101.0019

=== debian/changelog ===
kio-extras (4:25.12.0+p24.04+vstable+git20260101.0019-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 01 Jan 2026 00:19:29 +0000

## kio-extras 25.12.0+p24.04+vstable+git20260103.0020

=== debian/changelog ===
kio-extras (4:25.12.0+p24.04+vstable+git20260103.0020-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 03 Jan 2026 00:20:36 +0000

## kio-extras 25.12.0+p24.04+vstable+git20260104.0020

=== debian/changelog ===
kio-extras (4:25.12.0+p24.04+vstable+git20260104.0020-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 04 Jan 2026 00:20:38 +0000

## kio-extras 25.12.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 
 # KDE Applications Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
-set (RELEASE_SERVICE_VERSION_MINOR "11")
-set (RELEASE_SERVICE_VERSION_MICRO "90")
+set (RELEASE_SERVICE_VERSION_MINOR "12")
+set (RELEASE_SERVICE_VERSION_MICRO "1")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 project(kio-extras VERSION ${RELEASE_SERVICE_VERSION})

=== debian/changelog ===
kio-extras (4:25.12.1-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.12.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 08 Jan 2026 11:05:23 +0000

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                libappimage-dev (>= 0.1.10~) [linux-any],
                libimobiledevice-dev,
                libkdsoapwsdiscoveryclient-dev,
-               libkexiv2qt6-dev (>= 25.12.0~),
+               libkexiv2qt6-dev (>= 25.12.1~),
                libkf6archive-dev (>= 6.0.0~),
                libkf6codecs-dev,
                libkf6config-dev (>= 6.0.0~),

## kio-extras 25.12.1+p24.04+vstable+git20260128.0351

=== debian/changelog ===
kio-extras (4:25.12.1+p24.04+vstable+git20260128.0351-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 28 Jan 2026 03:51:11 +0000

kio-extras (4:25.12.1-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosd.kde@gmail.com>  Tue, 06 Jan 2026 23:31:38 +1000

## kio-extras 25.12.1+p24.04+vstable+git20260130.0848

=== debian/changelog ===
kio-extras (4:25.12.1+p24.04+vstable+git20260130.0848-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 30 Jan 2026 08:48:25 +0000

## kio-extras 25.12.1+p24.04+vunstable+git20260204.0834

=== debian/changelog ===
kio-extras (4:25.12.1+p24.04+vunstable+git20260204.0834-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 04 Feb 2026 08:34:15 +0000

## kio-extras 25.12.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # KDE Applications Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
 set (RELEASE_SERVICE_VERSION_MINOR "12")
-set (RELEASE_SERVICE_VERSION_MICRO "1")
+set (RELEASE_SERVICE_VERSION_MICRO "2")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 project(kio-extras VERSION ${RELEASE_SERVICE_VERSION})

=== debian/changelog ===
kio-extras (4:25.12.2-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.12.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 05 Feb 2026 12:24:18 +0000

kio-extras (4:25.12.1-0ubuntu2) resolute; urgency=medium

  * No-change rebuild for kf6-kio 6.22.1.

 -- Rik Mills <rikmills@kde.org>  Thu, 22 Jan 2026 22:08:51 +0000

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                libappimage-dev (>= 0.1.10~) [linux-any],
                libimobiledevice-dev,
                libkdsoapwsdiscoveryclient-dev,
-               libkexiv2qt6-dev (>= 25.12.1~),
+               libkexiv2qt6-dev (>= 25.12.2~),
                libkf6archive-dev (>= 6.0.0~),
                libkf6codecs-dev,
                libkf6config-dev (>= 6.0.0~),
